package de.intevation.flys.importer;

import de.intevation.flys.model.Range;
import de.intevation.flys.model.River;

import org.hibernate.Session;
import org.hibernate.Query;

import java.util.List;

import java.math.BigDecimal;

import org.apache.log4j.Logger;

public class ImportRange
implements   Comparable<ImportRange>
{
    private static Logger log = Logger.getLogger(ImportRange.class);

    protected Double from;
    protected Double to;

    protected Range peer;

    public ImportRange() {
    }

    public ImportRange(Double from, Double to) {
        this.from = from;
        this.to   = to;
    }

    private static final int compare(Double a, Double b) {
        if (a == null && b == null) {
            return 0;
        }
        if (a == null && b != null) {
            return -1;
        }
        if (a != null && b == null) {
            return +1;
        }
        return a.compareTo(b);
    }

    public int compareTo(ImportRange other) {
        int cmp = compare(from, other.from);
        if (cmp != 0) return cmp;
        return compare(to, other.to);
    }

    public Double getFrom() {
        return from;
    }

    public void setFrom(Double from) {
        this.from = from;
    }

    public Double getTo() {
        return to;
    }

    public void setTo(Double to) {
        this.to = to;
    }

    public Range getPeer(River river) {
        if (peer == null) {
            Session session = Importer.sessionHolder.get();
            Query query = session.createQuery(
                "from Range where a=:a and b=:b and river.id=:river");
            BigDecimal a = from != null ? BigDecimal.valueOf(from) : null;
            BigDecimal b = to   != null ? BigDecimal.valueOf(to) : null;
            query.setParameter("a", a);
            query.setParameter("b", b);
            query.setParameter("river", river.getId());
            List<Range> ranges = query.list();
            if (ranges.isEmpty()) {
                peer = new Range(a, b, river);
                session.save(peer);
            }
            else {
                peer = ranges.get(0);
            }
        }
        return peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
